;;defined tags and mutators
;; tag - 8 byte vector (i think it is enough for practical reasons)

(define generate-tag-u64
;;fast generation of unique tags of 8 bytes each
    (let ((base-tag (u8vector)))
    (set! base-tag (list->u8vector 
                    (cdr (u8vector->list 
                        (object->u8vector
                    (time->seconds (current-time)))))))
    (lambda ()
        ;;mutator
        (let loop ((i 0))
            (u8vector-set! base-tag i 
                            (bitwise-and 
                                (+ 1 (u8vector-ref base-tag i))
                            #xFF))
            (if (= 0 (u8vector-ref base-tag i))
                (if (< i 7) (loop (+ 1 i)))))
        (u8vector-copy base-tag))))

(define generate-question (lambda () (error "Not implemented yet!")))
(define generate-answer (lambda () (error "Not implemented yet!")))
(define check-answer (lambda () (error "Not implemented yet!")))
